using System.Linq;
using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using Terraria.ModLoader;
using Terraria.ID;
using MasterBuilder.NPCs;
 
namespace MasterBuilder.NPCs
{
	[AutoloadHead]
	public class Architect : ModNPC
	{
		public static bool Shop1 = true;
		public static bool Shop2 = false;
		public static bool Shop3 = false;
		public static bool Shop4 = false;
		public static bool Shop5 = false;
		public static bool S1A = false;
		public static bool S2A = false;
		public static bool S3A = false;
		public static bool S4A = false;
		public static bool S5A = false;
		public override string Texture
		{
			get
			{
				return "MasterBuilder/NPCs/Architect";
			}
		}

		public override bool Autoload(ref string name)
		{
			name = "Architect";
			return mod.Properties.Autoload;
		}

		public override void SetStaticDefaults()
		{
			DisplayName.SetDefault("Architect");
            Main.npcFrameCount[npc.type] = 26;   
			NPCID.Sets.AttackFrameCount[npc.type] = 5;
			NPCID.Sets.DangerDetectRange[npc.type] = 100;
			NPCID.Sets.AttackType[npc.type] = 3;
			NPCID.Sets.AttackTime[npc.type] = 35;
			NPCID.Sets.AttackAverageChance[npc.type] = 50;
			NPCID.Sets.HatOffsetY[npc.type] = -4;
		}

		public override void SetDefaults()
		{
			npc.townNPC = true;
            npc.friendly = true;
            npc.width = 18;
            npc.height = 40;
            npc.aiStyle = 7;
            npc.damage = 10;
            npc.defense = 100;
            npc.lifeMax = 250;
			npc.HitSound = SoundID.NPCHit1;
			npc.DeathSound = SoundID.NPCDeath1;
            npc.knockBackResist = 0.5f;
			animationType = NPCID.Guide;
        }
		
public override bool CanTownNPCSpawn(int numTownNPCs, int money)
        {
                    if (numTownNPCs >= 1)
                    {
                    return true;
                    }
            return false;
        }

 
        public override string TownNPCName()
        {                                       //NPC names
            switch (WorldGen.genRand.Next(6))
            {
                case 0:
                    return "Joe";
                case 1:
                    return "Mark";
                case 2:
                    return "Walter";
                case 3:
                    return "Archer";
				case 4:
                    return "Frido";
                default:
                    return "Li";
            }
        }
 
		public override void TownNPCAttackStrength(ref int damage, ref float knockback)
		{
			damage = 10;
			knockback = 8f;
		}

		public override void TownNPCAttackCooldown(ref int cooldown, ref int randExtraCooldown)
		{
			cooldown = 10;
			randExtraCooldown = 10;
		}

		public override void DrawTownAttackSwing(ref Texture2D item, ref int itemSize, ref float scale, ref Vector2 offset)//Allows you to customize how this town NPC's weapon is drawn when this NPC is swinging it (this NPC must have an attack type of 3). ItemType is the Texture2D instance of the item to be drawn (use Main.itemTexture[id of item]), itemSize is the width and height of the item's hitbox
		{
			scale = 1f;
			item = Main.itemTexture[ItemID.IronHammer]; //this defines the item that this npc will use
			itemSize = 40;
		}

		public override void TownNPCAttackSwing(ref int itemWidth, ref int itemHeight) //  Allows you to determine the width and height of the item this town NPC swings when it attacks, which controls the range of this NPC's swung weapon.
		{
			itemWidth = 50;
			itemHeight = 50;
		}
 
        public override string GetChat()
        {                                          //npc chat
                  int goblinTinkerer = NPC.FindFirstNPC(NPCID.GoblinTinkerer);
				  int partyGirl = NPC.FindFirstNPC(NPCID.PartyGirl);
				  int demolitionist = NPC.FindFirstNPC(NPCID.Demolitionist);
			if (Main.bloodMoon && partyGirl >= 0 && goblinTinkerer >=0 && Main.rand.Next(4) == 0)
			{
			return "If this dastardly " + Main.npc[partyGirl].GivenName + " isn't going to shut up, I'm letting " + Main.npc[goblinTinkerer].GivenName + " bite her.";
			}
			if (Main.bloodMoon)
			{
				switch (Main.rand.Next(4))
				{
				case 0:
				return "KILL THE ZOMBIES! KILL THE BUNNIES! IN THE NAME OF THE BLOO- oh sorry I didn't notice you here.";
                                case 1:
				return "Why hello there I'm just getting some blood buckets for a lake I'm making pleasedontaskanymorequestions";
				case 2:
				return "I like it when there is a gigantic horde of zombies behind our doors. But I HATE WHEN THEY BREAK MY DOORS!";
				case 3:
				return "Ah, the feeling that I'm not safe, the paranoia is embraced the moment the bloodmoon rises in the sky.";
				case 4:
				return "Are you interested in my religion? it invloves sacrifices to the bloody moon.";
				}
			}
			if (Main.invasionType == 1)
			{
				return "Do you know why I hate these goblins? They are mildly annoying.";
			}
			if (Main.invasionType == 3)
			{
				return "Hooray to pirates! they supply me with my golden furniture!";
			}
			if (Main.invasionType == 4)
			{
				return "Ah! Finally some proper plating to have my roof done!";
			}
                        if (demolitionist >= 0 && Main.rand.Next(5) == 0)
					{
					return "No explosives please, " + Main.npc[demolitionist].GivenName + " is already annoying enough.";
					}
            switch (Main.rand.Next(5))
            {                
                case 0:
				return "BUILDER POTIONS FREE FOR EVERYONE but you. ";
                case 1:
				return "What? Where I got my architect degree? There's an architect degree?";
                case 2:
				return "Did'ja know that wood somehow doesn't burn? Though under certain circumstances it does. Weird...";
                case 3:
				return "No, I am not the guy. I'm the dude.";
                case 4:
				return "Well, the one you recently made was ALMOST impressive. (not really)";
				case 5:
				return "So, you say that chests are furniture too. I reply: Screw you.";
                default:
				return "I saw your buildings but I am still not impressed";
            }
	}
 
        public override void SetChatButtons(ref string button, ref string button2)
        {
          if (Shop1)
			{
			button = "1st shop (Filler Blocks)";
			S4A = false;
			S1A = true;
			}
			if (Shop2)
			{
			button = "2nd shop (Building Blocks)";
			S1A = false;
			S2A = true;
			}
			if (Shop3)
			{
			button = "3rd shop (Basic Furniture)";
			S2A = false;
			S3A = true;
			}
			if (Shop4)
			{
			button = "4th shop (Advanced Furniture)";
			S3A = false;
			S4A = true;
			}
	  button2 = "Cycle shop";
        }
 
        public override void OnChatButtonClicked(bool firstButton, ref bool shop) 
		{
		if (firstButton)
            {
                shop = true;
            }
		else
				{
			if (Shop1 && S1A)
						{
						Shop2 = true;
						Shop1 = false;
						}
			if (Shop2 && S2A)
						{
						Shop3 = true;
						Shop2 = false;
						}
			if (Shop3 && S3A)
						{
						Shop4 = true;
						Shop3 = false;
						}
			if (Shop4 && S4A)
						{
						Shop1 = true;
						Shop4 = false;
						}
				}
		}

        Mod chadsfurniture = ModLoader.GetMod("chadsfurni");

        public override void SetupShop(Chest shop, ref int nextSlot)
        {
		if (Shop1)
			{
shop.item[nextSlot].SetDefaults (ItemID.DirtBlock);
			shop.item[nextSlot].shopCustomPrice = 1;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.ClayBlock);
			shop.item[nextSlot].shopCustomPrice = 1;
			nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.StoneBlock);
			shop.item[nextSlot].shopCustomPrice = 1;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.EbonstoneBlock);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.CrimstoneBlock);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.SandBlock);
			shop.item[nextSlot].shopCustomPrice = 1;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.EbonsandBlock);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.CrimsandBlock);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.Sandstone);
			shop.item[nextSlot].shopCustomPrice = 1;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.HardenedSand);
			shop.item[nextSlot].shopCustomPrice = 1;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.MudBlock);
			shop.item[nextSlot].shopCustomPrice = 1;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.Obsidian);
			shop.item[nextSlot].shopCustomPrice = 5;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.AshBlock);
			shop.item[nextSlot].shopCustomPrice = 1;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.SiltBlock);
			shop.item[nextSlot].shopCustomPrice = 100;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.SnowBlock);
			shop.item[nextSlot].shopCustomPrice = 1;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.IceBlock);
			shop.item[nextSlot].shopCustomPrice = 1;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.Marble);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.Granite);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.Cloud);
			shop.item[nextSlot].shopCustomPrice = 5;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.RainCloud);
			shop.item[nextSlot].shopCustomPrice = 5;
            nextSlot++;
if (Main.hardMode)
{		
shop.item[nextSlot].SetDefaults (ItemID.PearlstoneBlock);
			shop.item[nextSlot].shopCustomPrice = 5;
            nextSlot++;
shop.item[nextSlot].SetDefaults (ItemID.PearlsandBlock);
			shop.item[nextSlot].shopCustomPrice = 5;
            nextSlot++;
}
			}
				if (Shop2)
{
		shop.item[nextSlot].SetDefaults (ItemID.RedBrick);
			shop.item[nextSlot].shopCustomPrice = 2;
			nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Ebonwood);
			shop.item[nextSlot].shopCustomPrice = 10;
			nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Shadewood);
			shop.item[nextSlot].shopCustomPrice = 10;
			nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.DynastyWood);
			shop.item[nextSlot].shopCustomPrice = 100;
			nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.BorealWood);
			shop.item[nextSlot].shopCustomPrice = 10;
			nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.PalmWood);
			shop.item[nextSlot].shopCustomPrice = 15;
			nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.RichMahogany);
			shop.item[nextSlot].shopCustomPrice = 15;
			nextSlot++;
			if (Main.hardMode)
			{
			shop.item[nextSlot].SetDefaults (ItemID.Pearlwood);
			shop.item[nextSlot].shopCustomPrice = 25;
			nextSlot++;
			}
		shop.item[nextSlot].SetDefaults (ItemID.GrayBrick);
			shop.item[nextSlot].shopCustomPrice = 2;
			nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.Glass);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.ObsidianBrick);
			shop.item[nextSlot].shopCustomPrice = 5;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.IridescentBrick);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.SnowBrick);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.SandstoneBrick);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.EbonstoneBrick);
			shop.item[nextSlot].shopCustomPrice = 10;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.IceBrick);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.FleshBlock);
			shop.item[nextSlot].shopCustomPrice = 10;
            nextSlot++;		
		shop.item[nextSlot].SetDefaults (ItemID.StoneSlab);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.SandstoneSlab);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.MarbleBlock);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.GraniteBlock);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.CrystalBlock);
			shop.item[nextSlot].shopCustomPrice = 100;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.SunplateBlock);
			shop.item[nextSlot].shopCustomPrice = 10;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.Pumpkin);
			shop.item[nextSlot].shopCustomPrice = 2;
            nextSlot++;
			if (NPC.downedBoss3)
			{
				shop.item[nextSlot].SetDefaults (ItemID.PinkBrick);
				shop.item[nextSlot].shopCustomPrice = 50;
				nextSlot++;
				shop.item[nextSlot].SetDefaults (ItemID.GreenBrick);
				shop.item[nextSlot].shopCustomPrice = 50;
				nextSlot++;
				shop.item[nextSlot].SetDefaults (ItemID.BlueBrick);
				shop.item[nextSlot].shopCustomPrice = 50;
				nextSlot++;
			}
			if (NPC.downedMechBossAny)
			{
				shop.item[nextSlot].SetDefaults (ItemID.Cog);
				shop.item[nextSlot].shopCustomPrice = 2;
				nextSlot++;
				shop.item[nextSlot].SetDefaults (ItemID.AsphaltBlock);
				shop.item[nextSlot].shopCustomPrice = 2;
				nextSlot++;
				
			}
			if (Main.hardMode)
				{
		shop.item[nextSlot].SetDefaults (ItemID.PearlstoneBrick);
			shop.item[nextSlot].shopCustomPrice = 10;
            nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.RainbowBrick);
			shop.item[nextSlot].shopCustomPrice = 100;
			nextSlot++;
				}
				if (NPC.downedGolemBoss)
				{
					shop.item[nextSlot].SetDefaults (ItemID.LihzahrdBrick);
			shop.item[nextSlot].shopCustomPrice = 100;
			nextSlot++;
				}
			if (NPC.downedMartians)
				{
		shop.item[nextSlot].SetDefaults (ItemID.MartianConduitPlating);
			shop.item[nextSlot].shopCustomPrice = 25;
			nextSlot++;
				}
}
			if (Shop3)
			{
			shop.item[nextSlot].SetDefaults (ItemID.Wood);
			shop.item[nextSlot].shopCustomPrice = 5;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Torch);
			shop.item[nextSlot].shopCustomPrice = 25;
			nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Candle);
			shop.item[nextSlot].shopCustomPrice = 100;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.GoldChandelier);
			shop.item[nextSlot].shopCustomPrice = 250;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.ChainLantern);
			shop.item[nextSlot].shopCustomPrice = 200;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Mannequin);
			shop.item[nextSlot].shopCustomPrice = 100;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Womannquin);
			shop.item[nextSlot].shopCustomPrice = 100;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Cobweb);
			shop.item[nextSlot].shopCustomPrice = 20;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.WorkBench);
			shop.item[nextSlot].shopCustomPrice = 2000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.WoodenTable);
			shop.item[nextSlot].shopCustomPrice = 2000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.WoodenChair);
			shop.item[nextSlot].shopCustomPrice = 2000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.WoodenDoor);
			shop.item[nextSlot].shopCustomPrice = 2000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.WoodenBeam);
			shop.item[nextSlot].shopCustomPrice = 100;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Book);
			shop.item[nextSlot].shopCustomPrice = 250;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Fireplace);
			shop.item[nextSlot].shopCustomPrice = 3000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Chimney);
			shop.item[nextSlot].shopCustomPrice = 3000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.Furnace);
			shop.item[nextSlot].shopCustomPrice = 3000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.BanquetTable);
			shop.item[nextSlot].shopCustomPrice = 3000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.HeavyWorkBench);
			shop.item[nextSlot].shopCustomPrice = 3000;
            nextSlot++;
			
			if (Main.hardMode)
			{
			shop.item[nextSlot].SetDefaults (ItemID.BrickLayer);
			shop.item[nextSlot].shopCustomPrice = 150000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.PortableCementMixer);
			shop.item[nextSlot].shopCustomPrice = 150000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.PaintSprayer);
			shop.item[nextSlot].shopCustomPrice = 150000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.ExtendoGrip);
			shop.item[nextSlot].shopCustomPrice = 150000;
            nextSlot++;
			}
			shop.item[nextSlot].SetDefaults (ItemID.Ruler);
			shop.item[nextSlot].shopCustomPrice = 25000;
            nextSlot++;
			shop.item[nextSlot].SetDefaults (ItemID.EngineeringHelmet);
			shop.item[nextSlot].shopCustomPrice = 50000;
            nextSlot++;	
		}
            if (Shop4)
            {
                if (NPC.downedBoss3)
                {
                    shop.item[nextSlot].SetDefaults(ItemID.BoneWelder);
                    shop.item[nextSlot].shopCustomPrice = 20000;
                    nextSlot++;
                    if (chadsfurniture != null)
                    {
                        shop.item[nextSlot].SetDefaults(chadsfurniture.ItemType("printer"));
                        shop.item[nextSlot].shopCustomPrice = 20000;
                        nextSlot++;
                        shop.item[nextSlot].SetDefaults(chadsfurniture.ItemType("printer3"));
                        shop.item[nextSlot].shopCustomPrice = 20000;
                        nextSlot++;
                        shop.item[nextSlot].SetDefaults(chadsfurniture.ItemType("wallomatic"));
                        shop.item[nextSlot].shopCustomPrice = 20000;
                        nextSlot++;
                    }
                }
        shop.item[nextSlot].SetDefaults(ItemID.GlassKiln);
        shop.item[nextSlot].shopCustomPrice = 20000;
        nextSlot++;
        shop.item[nextSlot].SetDefaults (ItemID.SkyMill);
		shop.item[nextSlot].shopCustomPrice = 20000;
		nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.IceMachine);
		shop.item[nextSlot].shopCustomPrice = 20000;
		nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.HoneyDispenser);
		shop.item[nextSlot].shopCustomPrice = 20000;
		nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.Sawmill);
		shop.item[nextSlot].shopCustomPrice = 2000;
		nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.Loom);
		shop.item[nextSlot].shopCustomPrice = 2000;
		nextSlot++;
                if (Main.hardMode)
                {
                    if (chadsfurniture != null)
                    {
                        shop.item[nextSlot].SetDefaults(chadsfurniture.ItemType("RimpelstiltskinsLoom"));
                        shop.item[nextSlot].shopCustomPrice = 200000;
                        nextSlot++;
                    }
                }
		
			if (NPC.downedMechBossAny)
			{
		shop.item[nextSlot].SetDefaults (ItemID.FleshCloningVaat);
		shop.item[nextSlot].shopCustomPrice = 20000;
		nextSlot++;
		shop.item[nextSlot].SetDefaults (ItemID.SteampunkBoiler);
		shop.item[nextSlot].shopCustomPrice = 20000;
		nextSlot++;
			}
			if (NPC.downedPlantBoss)
			{
		shop.item[nextSlot].SetDefaults (ItemID.LihzahrdFurnace);
		shop.item[nextSlot].shopCustomPrice = 20000;
		nextSlot++;
			}
			}
		}
	}
}